#if !defined(AFX_XKEYMACSDLG_H__0FF191AD_88F0_4F11_B1EB_F140DB85BE35__INCLUDED_)
#define AFX_XKEYMACSDLG_H__0FF191AD_88F0_4F11_B1EB_F140DB85BE35__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// xkeymacsDlg.h : header file
//

BOOL CALLBACK EnumWndProc(HWND hWnd, LPARAM lParam);

#define PROCESS_SIZE        MAX_PATH

//
// task list structure
//
typedef struct _TASK_LIST {
    DWORD       dwProcessId;
//    DWORD       dwInheritedFromProcessId;
//    BOOL        flags;
//    HANDLE      hwnd;
    CHAR        ProcessName[PROCESS_SIZE];
//    CHAR        WindowTitle[TITLE_SIZE];
} TASK_LIST, *PTASK_LIST;

enum {MAX_TASKS		=   256};

//
// Function pointer types for accessing Toolhelp32 functions dynamically.
// By dynamically accessing these functions, we can do so only on Windows
// 95 and still run on Windows NT, which does not have these functions.
//
#include <tlhelp32.h>  // for Windows 95
typedef BOOL (WINAPI *PROCESSWALK)(HANDLE hSnapshot, LPPROCESSENTRY32 lppe);
typedef HANDLE (WINAPI *CREATESNAPSHOT)(DWORD dwFlags, DWORD th32ProcessID);

/////////////////////////////////////////////////////////////////////////////
// CXkeymacsDlg dialog

class CXkeymacsDlg : public CDialog
{
// Construction
public:
	TASK_LIST m_TaskList[MAX_TASKS];
	DWORD m_dwTasks;
	void InitDllData();
	CXkeymacsDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CXkeymacsDlg)
	enum { IDD = IDD_XKEYMACS };
	CButton	m_cUseDefault;
	CComboBox	m_cApplication;
	int		m_nKillRingMax;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CXkeymacsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void GetApplicationTitle(CString &rList, int nIndex = -1);
	int GetCurrentApplicationID();
	DWORD GetTaskList95(PTASK_LIST pTask, DWORD dwNumTasks);
	DWORD GetTaskList(PTASK_LIST pTask, DWORD dwNumTasks);
	DWORD GetTaskListNT(PTASK_LIST pTask, DWORD dwNumTasks);
	void SetDllData();
	int GetSavedSettingCount();
	BOOL IsDefault(CString sz);
	void EnableUseDefaultButton(BOOL bEnable);
	void CheckUseDefault(BOOL bCheckUseDefault);
	void UseDefault(BOOL bUseDefault);
	void DeleteAllRegistryData(HKEY hkey);
	void SetAllDialogData(UINT nCheck);
	CString m_szCurrentApplication;
	void InitApplicationList();
	int GetControlID(int nCommandType, int nKey);
	void UpdateDialogData(CString szApplicationName, BOOL bSaveAndValidate = TRUE);
	void GetDialogData(CString szApplicationName);
	void SetDialogData(CString szApplicationName);
	void SaveRegistryData();
	CXkeymacsData m_XkeymacsData[MAX_APP];
	void UpdateRegistryData(BOOL bSaveAndValidate = TRUE);
	void LoadRegistryData();

	// Generated message map functions
	//{{AFX_MSG(CXkeymacsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnApply();
	virtual void OnOK();
	afx_msg void OnSelchangeApplication();
	afx_msg void OnClearAll();
	afx_msg void OnSelectAll();
	afx_msg void OnLoadDefault();
	afx_msg void OnUseDefault();
	virtual void OnCancel();
	afx_msg void OnDropdownApplication();
	afx_msg void OnCo();
	afx_msg void OnCo2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XKEYMACSDLG_H__0FF191AD_88F0_4F11_B1EB_F140DB85BE35__INCLUDED_)
