// Commands.h: CCommands NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#include "xkeymacsdll.h"

#if !defined(AFX_COMMANDS_H__3AD9D537_AB40_40BB_9697_35F1BB0CA431__INCLUDED_)
#define AFX_COMMANDS_H__3AD9D537_AB40_40BB_9697_35F1BB0CA431__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCommands  
{
public:
	static int TransposeChars();
	static int Recenter();
	static int Repeat(BYTE bVk);
	static void bC_u(BOOL b);
	static BOOL bC_u();
	static int UniversalArgument();
	static int NumericArgumentMinus();
	static int NumericArgument9();
	static int NumericArgument8();
	static int NumericArgument7();
	static int NumericArgument6();
	static int NumericArgument5();
	static int NumericArgument4();
	static int NumericArgument3();
	static int NumericArgument2();
	static int NumericArgument1();
	static int NumericArgument0();
	static int MetaAlt();
	static int MetaEscape();
	static int Meta();
	static void bM_(BOOL b);
	static BOOL bM_();
	static int IgnoreSendMailCommand();
	static int ShellCommand();
	static int YankPop();
	static int Yank();
	static int KillRingSave();
	static int KillRegion();
	static int WriteFile();
	static int C_x();
	static void Reset();
	static void bC_x(BOOL b);
	static BOOL bC_x();
	static int ScrollDown();
	static int ScrollUp();
	static int SaveBuffer();
	static int MarkPage();
	static int Enter();
	static int Tab();
	static int FindFile();
	static int KeyboardQuit();
	static int SetMarkCommand();
	static int IconifyOrDeiconifyFrame();
	static int SaveBuffersKillEmacs();
	static int Undo();
	static int KillLine();
	static int DeleteChar();
	static int DeleteBackwardChar();
	static int EndOfBuffer();
	static int BeginningOfBuffer();
	static int QueryReplaceRegexp();
	static int QueryReplace();
	static int ToggleIME();
	static int OpenLine();
	static int PreviousLine();
	static int NextLine();
	static int BackwardWord();
	static int ForwardWord();
	static int EndOfLine();
	static int BackwardChar();
	static int BeginningOfLine();
	static int ForwardChar();
	CCommands();
	virtual ~CCommands();

protected:
	static int Reset(int rc);
	static void ClearNumericArgument();
	static void DecreaseNumericArgument();
	static DWORD CancelSelection();
	static BOOL CopyBackCharacter();
	static BOOL CopyNextCharacter();
	static BOOL m_bC_u;
	static BOOL m_bNegativeNumericArgument;
	static BOOL m_bDefaultNumericArgument;
	static int NumericArgument(int n);
	static BOOL m_bM_;
	static BOOL m_bC_x;
	static int ScrollUpDown(BOOL bUp);
	static DWORD ClickCaret();
	static BOOL m_bSetMark;
	static void ReleaseKey(BYTE bVk);
	static void DepressKey(BYTE bVk);
	static void SdKduSu(BYTE bVk1, BYTE bVk2 = 0);
	static void AdKduAu(BYTE bVk1, BYTE bVk2 = 0, BYTE bVk3 = 0);
	static void CdKduCu(BYTE bVk1, BYTE bVk2 = 0);
	static void Kdu(BYTE bVk1, BYTE bVk2 = 0);
	static DWORD m_nNumericArgument;
};

typedef struct KeyBind
{
	int nCommandType;
	BYTE bVk;
} KeyBind_t;

enum { MAX_KEY_BIND = 8 };

typedef struct Command
{
	char *szCommandName;
	int (*fCommand)();
	KeyBind_t keybind[MAX_KEY_BIND];
} Command_t;

static const Command_t Commands[] = {
	{"-", NULL, {0, 0}},
	{"backward-char", CCommands::BackwardChar, {{CONTROL, 'B'}, {0, 0}}},
	{"backward-word", CCommands::BackwardWord, {{META, 'B'}, {0, 0}}},
	{"beginning-of-buffer", CCommands::BeginningOfBuffer, {{META, 0xBC /* VK_OEM_COMMA */}, {0, 0}}},
	{"beginning-of-line", CCommands::BeginningOfLine, {{CONTROL, 'A'}, {0, 0}}},
	{"delete-backward-char", CCommands::DeleteBackwardChar, {{CONTROL, 'H'}, {0, 0}}},
	{"delete-char", CCommands::DeleteChar, {{CONTROL, 'D'}, {0, 0}}},
	{"end-of-buffer", CCommands::EndOfBuffer, {{META, 0xBE /* VK_OEM_PERIOD */}, {0, 0}}},
	{"end-of-line", CCommands::EndOfLine, {{CONTROL, 'E'}, {0, 0}}},
	{"Enter", CCommands::Enter, {{CONTROL, 'M'}, {0, 0}}},
	{"find-file", CCommands::FindFile, {{CONTROLX, 'F'}, {0, 0}}},
	{"forward-char", CCommands::ForwardChar, {{CONTROL, 'F'}, {0, 0}}},
	{"forward-word", CCommands::ForwardWord, {{META, 'F'}, {0, 0}}},
//	{"Ignore send mail command", CCommands::IgnoreSendMailCommand, {{CONTROL, VK_RETURN}, {CONTROL_SHIFT, VK_RETURN}, {0, 0}}},
	{"keyboard-quit", CCommands::KeyboardQuit, {{CONTROL, 'G'}, {0, 0}}},
	{"kill-line", CCommands::KillLine, {{CONTROL, 'K'}, {0, 0}}},
	{"kill-region", CCommands::KillRegion, {{CONTROL, 'W'}, {0, 0}}},
	{"kill-ring-save", CCommands::KillRingSave, {{META, 'W'}, {0, 0}}},
	{"mark-page", CCommands::MarkPage, {{CONTROLX, 'P'}, {0, 0}}},
	{"Meta", CCommands::Meta, {{CONTROL, 0xDB /* VK_OEM_4 */}, {0, 0}}},
	{"Meta for Alt", CCommands::MetaAlt, {{NONE, VK_MENU}, {NONE, VK_LMENU}, {NONE, VK_RMENU}, {0, 0}}},
	{"Meta for Escape", CCommands::MetaEscape, {{NONE, VK_ESCAPE}, {0, 0}}},
	{"next-line", CCommands::NextLine, {{CONTROL, 'N'}, {0, 0}}},
	{"numeric argument 0", CCommands::NumericArgument0, {{CONTROL, '0'}, {META, '0'}, {0, 0}}},
	{"numeric argument 1", CCommands::NumericArgument1, {{CONTROL, '1'}, {META, '1'}, {0, 0}}},
	{"numeric argument 2", CCommands::NumericArgument2, {{CONTROL, '2'}, {META, '2'}, {0, 0}}},
	{"numeric argument 3", CCommands::NumericArgument3, {{CONTROL, '3'}, {META, '3'}, {0, 0}}},
	{"numeric argument 4", CCommands::NumericArgument4, {{CONTROL, '4'}, {META, '4'}, {0, 0}}},
	{"numeric argument 5", CCommands::NumericArgument5, {{CONTROL, '5'}, {META, '5'}, {0, 0}}},
	{"numeric argument 6", CCommands::NumericArgument6, {{CONTROL, '6'}, {META, '6'}, {0, 0}}},
	{"numeric argument 7", CCommands::NumericArgument7, {{CONTROL, '7'}, {META, '7'}, {0, 0}}},
	{"numeric argument 8", CCommands::NumericArgument8, {{CONTROL, '8'}, {META, '8'}, {0, 0}}},
	{"numeric argument 9", CCommands::NumericArgument9, {{CONTROL, '9'}, {META, '9'}, {0, 0}}},
	{"numeric argument -", CCommands::NumericArgumentMinus, {{CONTROL, '-'}, {META, '-'}, {0, 0}}},
	{"open-line", CCommands::OpenLine, {{CONTROL, 'O'}, {0, 0}}},
	{"previous-line", CCommands::PreviousLine, {{CONTROL, 'P'}, {0, 0}}},
	{"query-replace", CCommands::QueryReplace, {{META_SHIFT, '5'}, {0, 0}}},
	{"query-replace-regexp", CCommands::QueryReplaceRegexp, {{CONTROL_META_SHIFT, '5'}, {0, 0}}},
	{"recenter", CCommands::Recenter, {{CONTROL, 'L'}, {0, 0}}},
	{"save-buffer", CCommands::SaveBuffer, {{CONTROLX, 'S'}, {0, 0}}},
	{"save-buffers-kill-emacs", CCommands::SaveBuffersKillEmacs, {{CONTROLX, 'C'}, {0, 0}}},
	{"scroll-down", CCommands::ScrollDown, {{META, 'V'}, {0, 0}}},
	{"scroll-up", CCommands::ScrollUp, {{CONTROL, 'V'}, {0, 0}}},
	{"set-mark-command", CCommands::SetMarkCommand, {{CONTROL, VK_SPACE}, {0, 0}}},
	{"shell-command", CCommands::ShellCommand, {{META_SHIFT, '1'}, {0, 0}}},
	{"Tab", CCommands::Tab, {{CONTROL, 'I'}, {0, 0}}},
	{"Toggle IME", CCommands::ToggleIME, {{CONTROLX, 'J'}, {CONTROL, 0xDC}, {CONTROL, 0xE2}, {0, 0}}},
	{"transpose-chars", CCommands::TransposeChars, {{CONTROL, 'T'}, {0, 0}}},
	{"undo", CCommands::Undo, {{CONTROLX, 'U'}, {CONTROL_SHIFT, 0xBD}, {CONTROL, 0xBF}, {CONTROL_SHIFT, 0xE2}, {0, 0}}},
	{"universal-argument", CCommands::UniversalArgument, {{CONTROL, 'U'}, {0, 0}}},
	{"write-file", CCommands::WriteFile, {{CONTROLX, 'W'}, {0, 0}}},
	{"yank", CCommands::Yank, {{CONTROL, 'Y'}, {0, 0}}},
	{"yank-pop", CCommands::YankPop, {{META, 'Y'}, {0, 0}}},
	{"", NULL, {0, 0}}
};

#endif // !defined(AFX_COMMANDS_H__3AD9D537_AB40_40BB_9697_35F1BB0CA431__INCLUDED_)
