// xkeymacsdll.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "resource.h"
#include "Utils.h"
#include <afxdllx.h>
#include <math.h>
#include <Imm.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static AFX_EXTENSION_MODULE XkeymacsdllDLL = { NULL, NULL };

static HINSTANCE g_hDllInst = NULL;

HINSTANCE GetThisHInst()
{
	return g_hDllInst;
}

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	g_hDllInst = hInstance;
	
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);

	if (dwReason == DLL_PROCESS_ATTACH) {
		TRACE0("XKEYMACSDLL.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(XkeymacsdllDLL, hInstance)) {
			return 0;
		}

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(XkeymacsdllDLL);
	} else if (dwReason == DLL_PROCESS_DETACH) {
		TRACE0("XKEYMACSDLL.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(XkeymacsdllDLL);
	}
	return 1;   // ok
}

//////////////////////////////////////////////////////////////////////
// CXkeymacsDll Class
//////////////////////////////////////////////////////////////////////

#include "xkeymacsDll.h"
#pragma data_seg(".xkmcs")
	HHOOK	CXkeymacsDll::m_hHookKeyboard = NULL;
	HHOOK	CXkeymacsDll::m_hHookCallWnd = NULL;
	HHOOK	CXkeymacsDll::m_hHookGetMessage = NULL;
	int		CXkeymacsDll::m_nEnable[MAX_APP][MAX_COMMAND_TYPE][MAX_KEY] = {'\0'};
	char	CXkeymacsDll::m_szSpecialApp[MAX_APP][CLASS_NAME_LENGTH] = {'\0'};
	HWND	CXkeymacsDll::m_hPrevWnd = 0;
	OSVERSIONINFO CXkeymacsDll::m_OsVersionInfo;
	SEARCH_DIRECTION CXkeymacsDll::m_CurrentDirection = NA;
	BOOL	CXkeymacsDll::m_bRightControl	= FALSE;
	BOOL	CXkeymacsDll::m_bRightAlt		= FALSE;
	BOOL	CXkeymacsDll::m_bRightShift		= FALSE;
	BOOL	CXkeymacsDll::m_bImeComposition	= FALSE;
	BOOL	CXkeymacsDll::m_bHook			= TRUE;
	NOTIFYICONDATA CXkeymacsDll::m_stNtfyIcon[MAX_ICON] = {'\0'};
	HICON	CXkeymacsDll::m_hDisable[MAX_ICON] = {'\0'};
	HICON	CXkeymacsDll::m_hEnable[MAX_ICON] = {'\0'};
	BOOL	CXkeymacsDll::m_bIcon[MAX_ICON] = {'\0'};
	char	CXkeymacsDll::m_szIMEName[MAX_PATH] = {'\0'};
	BOOL	CXkeymacsDll::m_bSetMark = FALSE;
	int		CXkeymacsDll::m_nKillRingMax[MAX_APP] = {'\0'};
	int		*CXkeymacsDll::m_pnKillRingMax = NULL;
	CStringList *CXkeymacsDll::m_pKillRing[MAX_APP] = {'\0'};
	int		CXkeymacsDll::m_nKillRing = 0;
#pragma data_seg()

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXkeymacsDll::CXkeymacsDll()
{
	HKL hKL = GetKeyboardLayout(0);
	if (ImmIsIME(hKL)) {
		ImmGetIMEFileName(hKL, m_szIMEName, sizeof(m_szIMEName));
	}
}

CXkeymacsDll::~CXkeymacsDll()
{

}

int CXkeymacsDll::ModifyShell_NotifyIcon(icons icon, BOOL bNewStatus)
{
	if (m_stNtfyIcon[icon].hIcon == (bNewStatus ? m_hEnable[icon] : m_hDisable[icon])) {
		return TRUE;
	} else {
		m_stNtfyIcon[icon].hIcon = (bNewStatus ? m_hEnable[icon] : m_hDisable[icon]);
	}
	return DoShell_NotifyIcon(icon, NIM_MODIFY);
}

void CXkeymacsDll::SetNotifyIconData(icons icon, NOTIFYICONDATA stNtfyIcon, HICON hIconEnable, HICON hIconDisable, BOOL bEnable)
{
	m_hEnable[icon] = hIconEnable;
	m_hDisable[icon] = hIconDisable;
	m_bIcon[icon] = bEnable;
	m_stNtfyIcon[icon] = stNtfyIcon;
	AddShell_NotifyIcon(icon);
}

void CXkeymacsDll::EnableShell_NotifyIcon(icons icon, BOOL bEnable)
{
	DeleteShell_NotifyIcon(icon);
	m_bIcon[icon] = bEnable;
	AddShell_NotifyIcon(icon);
}


BOOL CXkeymacsDll::DoShell_NotifyIcon(icons icon, DWORD dwMessage)
{
	if (m_bIcon[icon]) {
		return ::Shell_NotifyIcon(dwMessage, &m_stNtfyIcon[icon]);
	} else {
		return TRUE;
	}
}

int CXkeymacsDll::AddShell_NotifyIcon(icons icon)
{
	return DoShell_NotifyIcon(icon, NIM_ADD);
}

int CXkeymacsDll::DeleteShell_NotifyIcon(icons icon)
{
	return DoShell_NotifyIcon(icon, NIM_DELETE);
}

// set keyboard hook
BOOL CXkeymacsDll::SetKeyboardHook()
{
	m_hHookKeyboard = ::SetWindowsHookEx(WH_KEYBOARD, (HOOKPROC)KeyboardProc, GetThisHInst(), 0);
	if (!m_hHookKeyboard) {
		return FALSE;
	}

	m_hHookCallWnd = ::SetWindowsHookEx(WH_CALLWNDPROC, (HOOKPROC)CallWndProc, GetThisHInst(), 0);
//	if (!m_hHookCallWnd) {
//		return FALSE;
//	}

	m_hHookGetMessage = ::SetWindowsHookEx(WH_GETMESSAGE, (HOOKPROC)GetMessageProc, GetThisHInst(), 0);

	AddShell_NotifyIcon(MAIN_ICON);

	return TRUE;
}

// release keyboard hook
BOOL CXkeymacsDll::ReleaseKeyboardHook()
{
	BOOL bKeyboard = TRUE;
	BOOL bCallWnd = TRUE;
	BOOL bGetMessage = TRUE;

	if (m_hHookKeyboard) {
		bKeyboard = ::UnhookWindowsHookEx(m_hHookKeyboard);
	}
	m_hHookKeyboard = NULL;

	if (m_hHookCallWnd) {
		bCallWnd = ::UnhookWindowsHookEx(m_hHookCallWnd);
	}
	m_hHookCallWnd = NULL;

	if (m_hHookGetMessage) {
		bGetMessage = ::UnhookWindowsHookEx(m_hHookGetMessage);
	}
	m_hHookGetMessage = NULL;

	DoShell_NotifyIcon(MAIN_ICON, NIM_DELETE);
	DoShell_NotifyIcon(CX_ICON, NIM_DELETE);
	DoShell_NotifyIcon(SHIFT_ICON, NIM_DELETE);
	DoShell_NotifyIcon(CTRL_ICON, NIM_DELETE);
	DoShell_NotifyIcon(ALT_ICON, NIM_DELETE);

	return bKeyboard && bCallWnd && bGetMessage;
}

void CXkeymacsDll::SetKeyboardHookFlag(BOOL bFlag)
{
	m_bHook = bFlag;

	if (m_bHook) {
		m_stNtfyIcon[MAIN_ICON].hIcon = m_hEnable[MAIN_ICON];
	} else {
		m_stNtfyIcon[MAIN_ICON].hIcon = m_hDisable[MAIN_ICON];
	}
	DoShell_NotifyIcon(MAIN_ICON, NIM_MODIFY);
}

// if be keyboard hook, return TRUE
BOOL CXkeymacsDll::IsKeyboardHook()
{
//	if (m_hHookKeyboard) {
	if (m_bHook) {
		return TRUE;
	}

	return FALSE;
}

LRESULT CALLBACK CXkeymacsDll::CallWndProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	if (0 <= nCode) {
		CWPSTRUCT &cwps = *(CWPSTRUCT *)lParam;
		switch (cwps.message) {
		case WM_IME_STARTCOMPOSITION:
			m_bImeComposition = TRUE;
			break;
		case WM_IME_ENDCOMPOSITION:
			m_bImeComposition = FALSE;
			break;
		}
	}
	return CallNextHookEx(m_hHookCallWnd, nCode, wParam, lParam);
}

LRESULT CALLBACK CXkeymacsDll::GetMessageProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	MSG &msg = (*(MSG *)lParam);

	switch (msg.message) {
	case WM_IME_STARTCOMPOSITION:
		m_bImeComposition = TRUE;
		break;
	case WM_IME_ENDCOMPOSITION:
		m_bImeComposition = FALSE;
		break;
	}
	return CallNextHookEx(m_hHookGetMessage, nCode, wParam, lParam);
}

// return true if the key is down
inline BOOL CXkeymacsDll::IsDown(BYTE bVk)
{
	return (GetKeyState(bVk) < 0);
}

// Do keybd_event
void CXkeymacsDll::DoKeybd_event(BYTE bVk, DWORD dwFlags)
{
	// Set KEYEVENTF_EXTENDEDKEY if needed
	switch (bVk) {
	case VK_CONTROL:
		if (m_bRightControl) {		// Right Ctrl
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		}
		break;

	case VK_MENU:
		if (m_bRightAlt) {			// Right Alt
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		}
		break;

	case VK_SHIFT:
		if (m_bRightShift) {		// Right Shift
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		}
		break;

	case VK_PAUSE:
		if (IsDown(VK_CONTROL)) {	// Break
			dwFlags |= KEYEVENTF_EXTENDEDKEY;
		}
		break;

	case VK_INSERT:
	case VK_DELETE:
	case VK_HOME:
	case VK_END:
	case VK_NEXT:
	case VK_PRIOR:
	case VK_UP:
	case VK_DOWN:
	case VK_RIGHT:
	case VK_LEFT:
	case VK_NUMLOCK:
	case VK_PRINT:
		dwFlags |= KEYEVENTF_EXTENDEDKEY;
		break;

	default:
		break;
	}

	keybd_event(bVk, MapVirtualKey(bVk, 0), dwFlags, 0);
}

// the key is being depressed
inline void CXkeymacsDll::DepressKey(BYTE bVk)	// bVk is virtual-key code, MSDN said
{
	DoKeybd_event(bVk, 0);
}

// the key is being released
inline void CXkeymacsDll::ReleaseKey(BYTE bVk)	// bVk is virtual-key code, MSDN said
{
	DoKeybd_event(bVk, KEYEVENTF_KEYUP);
}

// bVk down, bVk up
inline void CXkeymacsDll::Kdu(BYTE bVk, int n = 1)
{
	if (n == 0) {
		n = 1;
	}
	while (n--) {
		DepressKey(bVk);
		ReleaseKey(bVk);
	}
}

// control up, bVk down and bVk up n times (at least 1 times), control down
inline void CXkeymacsDll::CuKduCd(BYTE bVk, int n = 1)
{
	BYTE ks[256];

	GetKeyboardState( ks );
	ks[ VK_CONTROL ] = 0;
	SetKeyboardState( ks );

	ReleaseKey(VK_CONTROL);
	Kdu(bVk, n);
	DepressKey(VK_CONTROL);

	GetKeyboardState( ks );
	ks[ VK_CONTROL ] = 1;
	SetKeyboardState( ks );
}

inline void CXkeymacsDll::CuKduKduCd(BYTE bVk1, BYTE bVk2)
{
	BYTE ks[256];

	GetKeyboardState( ks );
	ks[ VK_CONTROL ] = 0;
	SetKeyboardState( ks );

	ReleaseKey(VK_CONTROL);
	Kdu(bVk1);
	Kdu(bVk2);
	DepressKey(VK_CONTROL);

	GetKeyboardState( ks );
	ks[ VK_CONTROL ] = 1;
	SetKeyboardState( ks );
}

// if control is down: control up, atl down, bVk down, bVk up, alt up, control down
inline void CXkeymacsDll::CuAdKduAuCd(BYTE bVk)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_MENU);
	Kdu(bVk);
	ReleaseKey(VK_MENU);
	DepressKey(VK_CONTROL);
}

// if control is down: control up, atl down, bVk1 down, bVk1 up, bVk2 down, bVk2 up, alt up, control down
inline void CXkeymacsDll::CuAdKduKduAuCd(BYTE bVk1, BYTE bVk2)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_MENU);
	Kdu(bVk1);
	Kdu(bVk2);
	ReleaseKey(VK_MENU);
	DepressKey(VK_CONTROL);
}

// if control is down: control up, atl down, bVk1 down, bVk1 up, ...,  bVk3 down, bVk3 up, alt up, control down
inline void CXkeymacsDll::CuAdKduKduKduAuCd(BYTE bVk1, BYTE bVk2, BYTE bVk3)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_MENU);
	Kdu(bVk1);
	Kdu(bVk2);
	Kdu(bVk3);
	ReleaseKey(VK_MENU);
	DepressKey(VK_CONTROL);
}

// control up, shift down, bVk down, bVk up, shift up, control down
inline void CXkeymacsDll::CuSdKduSuCd(BYTE bVk, int n = 1)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_SHIFT);
	Kdu(bVk, n);
	ReleaseKey(VK_SHIFT);
	DepressKey(VK_CONTROL);
}

// control up, shift down, bVk1 down, bVk1 up, bVk2 down, bVk2 up, shift up, control down
inline void CXkeymacsDll::CuSdKduKduSuCd(BYTE bVk1, BYTE bVk2)
{
	ReleaseKey(VK_CONTROL);
	DepressKey(VK_SHIFT);
	Kdu(bVk1);
	Kdu(bVk2);
	ReleaseKey(VK_SHIFT);
	DepressKey(VK_CONTROL);
}

// alt up, bVk down, bVk up, alt down
inline void CXkeymacsDll::AuKduAd(BYTE bVk)
{
	ReleaseKey(VK_MENU);
	Kdu(bVk);
	DepressKey(VK_MENU);
}

// control down, bVk down, bVk up, control up
inline void CXkeymacsDll::CdKduCu(BYTE bVk, int n = 1)
{
	DepressKey(VK_CONTROL);
	Kdu(bVk, n);
	ReleaseKey(VK_CONTROL);
}

// control down, bVk1 down, bVk1 up, bVk2 down, bVk2 up, control up
inline void CXkeymacsDll::CdKduKduCu(BYTE bVk1, BYTE bVk2)
{
	DepressKey(VK_CONTROL);
	Kdu(bVk1);
	Kdu(bVk2);
	ReleaseKey(VK_CONTROL);
}

inline BOOL CXkeymacsDll::CopyBackCharacter()
{
	if (!OpenClipboard(NULL)) {
		return FALSE;
	}
	if (!EmptyClipboard()) {
		return FALSE;
	}
	if (!CloseClipboard()) {
		return FALSE;
	}

	CuSdKduSuCd(VK_LEFT);
	Kdu('C');
	CuKduCd(VK_RIGHT);

	return TRUE;
}

// Copy next character of the cursor if the caret is NOT at end of the file
// Move the caret to left if caret is at end of the file
inline BOOL CXkeymacsDll::CopyNextCharacter()
{
	if (!OpenClipboard(NULL)) {
		return FALSE;
	}
	if (!EmptyClipboard()) {
		return FALSE;
	}
	if (!CloseClipboard()) {
		return FALSE;
	}

	CuSdKduSuCd(VK_RIGHT);
	Kdu('C');
	CuKduCd(VK_LEFT);

	return TRUE;
}

inline void CXkeymacsDll::ToggleIME()
{
	HKL hKL = GetKeyboardLayout(0);
	if (ImmIsIME(hKL)) {
		// default
		HWND hWnd = GetFocus();
		HIMC hIMC = ImmGetContext(hWnd);
		ImmSetOpenStatus(hIMC, !ImmGetOpenStatus(hIMC));
		ImmReleaseContext(hWnd, hIMC);
	} else {
		CuKduCd(VK_KANJI);
	}
}

CSearchKey::CSearchKey()
{
	m_bFindWhat				= 'N';
	m_bDirectionForward		= 'D';
	m_bDirectionBackward	= 'U';
	m_bSearchOption			= 0;
}

CSearchKey::CSearchKey(char *szApplicationName, int nApplicationNameLength, CString *szDialogTitle)
{
	m_bFindWhat				= 'N';
	m_bDirectionForward		= 'D';
	m_bDirectionBackward	= 'U';
	m_bSearchOption			= 0;

	if (!strnicmp(szApplicationName, "wordpad.exe", nApplicationNameLength) ||
		!strnicmp(szApplicationName, "123w.exe", nApplicationNameLength)) {
		m_bDirectionForward = m_bDirectionBackward = 0;
	} else if (!strnicmp(szApplicationName, "nlnotes.exe", nApplicationNameLength)) {
		// Lotus Notes
		m_bFindWhat				= 'F';
		m_bDirectionForward		= 'D';
		m_bDirectionBackward	= 'B';
		m_bSearchOption			= 'O';
	} else if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength)) {
		// Becky!
		m_bFindWhat			= 'F';
		if (!szDialogTitle->Compare("{")) {
			m_bDirectionForward		= 'O';
			m_bDirectionBackward	= 'B';
		} else {
			m_bDirectionForward		= 0;
			m_bDirectionBackward	= 0;
		}
	} else if (!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength)) {
		m_bFindWhat				= 0;
		m_bDirectionForward		= 'D';
		m_bDirectionBackward	= 'U';
	} else if (!strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength)) {
		m_bFindWhat				= 'S';
		m_bDirectionForward		= 'N';
		m_bDirectionBackward	= 'P';
	}

	if (!strnicmp(szApplicationName, "outlook.exe", nApplicationNameLength) &&
		!szDialogTitle->Compare("Find")) {
		// Outlook (English version)
		m_bDirectionForward = m_bDirectionBackward = 0;
	}
}

CSearch::CSearch(char* szApplicationName, int nApplicationNameLength)
{
	CUtils::GetFindDialogTitle(szApplicationName, nApplicationNameLength, &m_szDialogTitle);

	m_pKey = new CSearchKey(szApplicationName, nApplicationNameLength, &m_szDialogTitle);
}

inline void CXkeymacsDll::SearchSetDirection(SEARCH_DIRECTION direction, char *szApplicationName,
											 int nApplicationNameLength, BOOL *bOriginalM_b, BOOL *bOriginalM_f,
											 CSearch *pSearch)
{
	if ((direction != FORWARD) && (direction != BACKWARD)) {
		ASSERT(0);
	}

	if (pSearch->m_pKey->m_bDirectionForward == 0 && pSearch->m_pKey->m_bDirectionBackward == 0) {
		return;
	} else if (!strnicmp(szApplicationName, "winword.exe", nApplicationNameLength)) {
		// Microsoft Word
		CuAdKduAuCd('M');
		CuAdKduAuCd(0xBA);	// VK_OEM_1	Used for miscellaneous characters; it can vary by keyboard. 
							//			Windows 2000/XP: For the US standard keyboard, the ';:' key
		CuKduKduCd(VK_UP, VK_UP);
		if (direction == BACKWARD) {
			CuKduCd(VK_DOWN);
		}
		CuAdKduAuCd('N');
		CuKduCd(VK_ESCAPE);
	} else if (!strnicmp(szApplicationName, "nlnotes.exe", nApplicationNameLength)) {
		// Lotus Notes
		BYTE bDirection	= 0;

		if (direction == FORWARD) {
			bDirection = pSearch->m_pKey->m_bDirectionForward;
		} else if (direction == BACKWARD) {
			bDirection = pSearch->m_pKey->m_bDirectionBackward;
		}

		if (bDirection == 'B') {
			*bOriginalM_b = TRUE;
		}
		CuAdKduKduKduAuCd(pSearch->m_pKey->m_bSearchOption, bDirection, pSearch->m_pKey->m_bSearchOption);
		{
			CString szDialogTitle;
			CUtils::GetFindDialogTitle(szApplicationName, nApplicationNameLength, &szDialogTitle);

			int n = 2;
			if (!szDialogTitle.Compare("") ||
				!szDialogTitle.Compare("Find")) {
				n = 1;
			}
			CuSdKduSuCd(VK_TAB, n);
		}
		CuKduCd(VK_END);
	} else if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength)) {
		// Becky!
		CuAdKduAuCd(pSearch->m_pKey->m_bDirectionForward);
		if (direction == BACKWARD) {
			CuKduCd(VK_UP);
		}
		CuKduCd(VK_TAB, 4);
		CuKduCd(VK_END);
	} else if (!strnicmp(szApplicationName, "netscp6.exe", nApplicationNameLength) ||
			   !strnicmp(szApplicationName, "mozilla.exe", nApplicationNameLength)) {
		// Netscape, Mozilla
		CuKduCd(VK_TAB, 3);
		CuKduCd(VK_SPACE);
		CuSdKduSuCd(VK_TAB, 3);
	} else {
		// default
		BYTE bDirection	= 0;
	
		if (direction == FORWARD) {
			bDirection = pSearch->m_pKey->m_bDirectionForward;
		} else if (direction == BACKWARD) {
			bDirection = pSearch->m_pKey->m_bDirectionBackward;
		}

		if (pSearch->m_pKey->m_bFindWhat == 'F') {
			*bOriginalM_f = TRUE;
		}
		if (bDirection == 'B') {
			*bOriginalM_b = TRUE;
		}
//		CString sz;
//		sz.Format("%c, %c", bDirection, pSearch->m_pKey->m_bFindWhat);
//		AfxMessageBox(sz);
		CuAdKduKduAuCd(bDirection, pSearch->m_pKey->m_bFindWhat);
	}
}

inline void CXkeymacsDll::Search(SEARCH_DIRECTION direction, char *szApplicationName, int nApplicationNameLength,
								 BOOL *bOriginalC_f, BOOL *bOriginalM_b, BOOL *bOriginalM_f)
{
	if ((direction != FORWARD) && (direction != BACKWARD)) {
		ASSERT(0);
	}

	CSearch *pSearch;
	pSearch = new CSearch(szApplicationName, nApplicationNameLength);

	if (pSearch->m_szDialogTitle.IsEmpty()) {
		// Find Dialog is not.
		// Open Find dialog
		if ((!strnicmp(szApplicationName, "notepad.exe", nApplicationNameLength)) &&
			((m_OsVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) ||
			 ((m_OsVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT) &&
			  (m_OsVersionInfo.dwMajorVersion <= 4)))) {
			// notepad on Win9x or NT
			*bOriginalM_f = TRUE;
			CuAdKduKduAuCd('S', 'F');
		} else if (!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength)) {
			// sakura
			CuAdKduKduAuCd('S', VK_RETURN);
		} else if (!strnicmp(szApplicationName, "msimn.exe", nApplicationNameLength)) {
			CuKduCd(VK_F3);
		} else if (!strnicmp(szApplicationName, "opera.exe", nApplicationNameLength) ||
				   !strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength) ||
				   !strnicmp(szApplicationName, "netscp6.exe", nApplicationNameLength) ||
				   !strnicmp(szApplicationName, "mozilla.exe", nApplicationNameLength)) {
			*bOriginalC_f = TRUE;
			Kdu('F');
		} else {
			// default
//			*bOriginalC_f = TRUE;
//			Kdu('F');
			*bOriginalM_f = TRUE;
			CuAdKduKduAuCd('E', 'F');
		}

		// Set Direction w/o with sakura.exe if Find dialog already exist
		if (!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "wordpro.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "netscp6.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "mozilla.exe", nApplicationNameLength)) {
			// sakura, wordpro, hidemaru, Netscape, Mozilla
		} else if (!strnicmp(szApplicationName, "iexplore.exe", nApplicationNameLength)) {
			// IE
			// I want to set direction but IE does not allow me.
		} else {
			// default
			SearchSetDirection(direction, szApplicationName, nApplicationNameLength,
							   bOriginalM_b, bOriginalM_f, pSearch);
		}
		m_CurrentDirection = direction;
	} else {
		// Find Dialog is opened.
		if (!strnicmp(szApplicationName, "sakura.exe", nApplicationNameLength) ||
			!strnicmp(szApplicationName, "hidemaru.exe", nApplicationNameLength)) {
			BYTE bDirection = 0;

			if (direction == FORWARD) {
				bDirection = pSearch->m_pKey->m_bDirectionForward;
			} else if (direction == BACKWARD) {
				bDirection = pSearch->m_pKey->m_bDirectionBackward;
			} else {
				ASSERT(0);
			}
			CuAdKduAuCd(bDirection);
		} else {
			if (m_CurrentDirection != direction) {
				// Set Direction if Find dialog already exist
				SearchSetDirection(direction, szApplicationName, nApplicationNameLength,
								   bOriginalM_b, bOriginalM_f, pSearch);
				m_CurrentDirection = direction;
				return;
			}

			// "Find Next(F)" if Find dialog already exist
			CuKduCd(VK_RETURN);

			// open Find dialog again
			if (!strnicmp(szApplicationName, "outlook.exe", nApplicationNameLength) &&
				pSearch->m_szDialogTitle.Compare("")) {
				// Outlook (w/o Japanese version)
				*bOriginalM_f = TRUE;
				CuAdKduKduAuCd('E', 'F');
			} else if (!strnicmp(szApplicationName, "msdev.exe", nApplicationNameLength)) {
				// Visual C++
				*bOriginalC_f = TRUE;
				Kdu('F');
			} else if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength)) {
				// Becky!
//				*bOriginalM_f = TRUE;
//				CuAdKduKduAuCd('E', 'F');
//				*bOriginalC_f = TRUE;
//				Kdu('F');
			}

			// set cursor at end of FindWhat
			if (!strnicmp(szApplicationName, "b2.exe", nApplicationNameLength)) {
//				CuKduCd(VK_TAB, 4);
//				CuKduCd(VK_DOWN);
			} else if (!strnicmp(szApplicationName, "netscp6.exe", nApplicationNameLength) ||
					   !strnicmp(szApplicationName, "mozilla.exe", nApplicationNameLength)) {
				// do nothing
			} else {
				if (pSearch->m_pKey->m_bFindWhat == 'F') {
					*bOriginalM_f = TRUE;
				}
				CuAdKduAuCd(pSearch->m_pKey->m_bFindWhat);
				if(!strnicmp(szApplicationName, "winword.exe", nApplicationNameLength)) {
					CuKduCd(VK_ESCAPE);
				}
			}
			CuKduCd(VK_END);
		}
	}
	delete pSearch;
}

// emulate emacs	// cf virtual-key code
LRESULT CALLBACK CXkeymacsDll::KeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
{
/** /
	{
		// Show key code
		CString sz;
		sz.Format("%c: 0x%x", wParam, wParam);
		AfxMessageBox(sz);
	}
/**/

	static BOOL bImeComposition	= FALSE;
	static BOOL bC_u		 = FALSE;
	static BOOL bC_x		 = FALSE;
	static BOOL bM_			 = FALSE;
	static BOOL bOriginalC_f = FALSE;
	static BOOL bOriginalC_h = FALSE;
	static BOOL bOriginalC_o = FALSE;
	static BOOL bOriginalC_v = FALSE;
	static BOOL bOriginalC_x = FALSE;
	static BOOL bOriginalC_z = FALSE;
	static BOOL bOriginalM_b = FALSE;
	static BOOL bOriginalM_f = FALSE;
	static int	nRepeat		 = 0;
	HWND		hCurrentWnd = GetFocus();
	static char szApplicationName[MAX_PATH];
	static int	nApp = 0;
	static WPARAM wLastParam = 0;

	if (nCode < 0 || nCode == HC_NOREMOVE) {
		goto DO_NOTHING;
	}

	if (lParam & 0x80000000) {
		goto DO_NOTHING;
	}

	if (!m_hPrevWnd || (m_hPrevWnd != hCurrentWnd) || (bImeComposition != m_bImeComposition)) {
		if (m_hPrevWnd != hCurrentWnd) {
			m_bImeComposition = FALSE;
		}

		CString szApplicationNameOrg = szApplicationName;
		memset(szApplicationName, 0, sizeof(szApplicationName));

		if (m_bImeComposition) {
			HKL hKL = GetKeyboardLayout(0);
			if (ImmIsIME(hKL)) {
				ImmGetIMEFileName(hKL, szApplicationName, sizeof(szApplicationName));
				strncpy(m_szIMEName, szApplicationName, sizeof(m_szIMEName));
			} else {
				// ImmIsIME return 0 on Word2002, Excel2002, etc. with IME2002, so...
				// strncpy(szApplicationName, "imjp81.ime", sizeof(szApplicationName));
				strncpy(szApplicationName, m_szIMEName, sizeof(szApplicationName));
			}
		} else {
			GetModuleFileName(NULL, szApplicationName, sizeof(szApplicationName));
			CString szFn(szApplicationName);
			szFn.Delete(0, szFn.ReverseFind('\\') + 1);
			ZeroMemory(szApplicationName, sizeof(szApplicationName));
			strncpy(szApplicationName, szFn, szFn.GetLength());
			{
//				CString sz;
//				sz.Format("a%sa", szApplicationName);
//				AfxMessageBox(sz);
			}
			if (!szApplicationName[0] || !strcmp(szApplicationName, "xkeymacs.exe")) {
				memset(szApplicationName, 0, sizeof(szApplicationName));
				if (m_OsVersionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) {
					strcpy(szApplicationName, "WINOA386.MOD");
				} else {
					strcpy(szApplicationName, "CMD.exe");
				}
			}
		}

		if (strnicmp(m_szSpecialApp[nApp], szApplicationName, sizeof(szApplicationName))) {
			for (nApp = 0; nApp < MAX_APP; nApp++) {
				if (!strnicmp(m_szSpecialApp[nApp], szApplicationName, sizeof(szApplicationName))) {
					break;
				}
			}
			if (nApp == MAX_APP) {
				for (nApp = 0; nApp < MAX_APP; nApp++) {
					if (!strnicmp(m_szSpecialApp[nApp], "Default", sizeof(szApplicationName))) {
						break;
					}
				}
				if (nApp == MAX_APP) {
					nApp = 0;
				}
			}
		}

		m_hPrevWnd		= hCurrentWnd;
		bImeComposition	= m_bImeComposition;
		ModifyShell_NotifyIcon(CX_ICON, FALSE);
		bC_u			= FALSE;
		bC_x			= FALSE;
		bM_				= FALSE;
		nRepeat			= 0;
		wLastParam		= 0;
		m_pKillRing[nApp]	= new CStringList();
		m_pnKillRingMax	= &(m_nKillRingMax[nApp]);

		m_OsVersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		GetVersionEx(&m_OsVersionInfo);

		if (strcmp(szApplicationName, szApplicationNameOrg)) {
			m_CurrentDirection		= NA;
		}
	}

	// Do Nothing for Meadow, Mule for Win32, ... if those use default setting.
	{
		if (!strnicmp(m_szSpecialApp[nApp], "Default", sizeof(szApplicationName))) {
			if (!strnicmp(szApplicationName, "Meadow95.exe", sizeof(szApplicationName)) ||
				!strnicmp(szApplicationName, "MeadowNT.exe", sizeof(szApplicationName)) ||
				!strnicmp(szApplicationName, "mule.exe", sizeof(szApplicationName)) ||
				!strnicmp(szApplicationName, "mulent.exe", sizeof(szApplicationName)) ||
				!strnicmp(szApplicationName, "mulecd.exe", sizeof(szApplicationName)) ||
				!strnicmp(szApplicationName, "xyzzy.exe", sizeof(szApplicationName)) ||
				!strnicmp(szApplicationName, "ttermpro.exe", sizeof(szApplicationName)) ||
				!strnicmp(szApplicationName, "astecx.exe", sizeof(szApplicationName))) {
				goto DO_NOTHING;
			}
		}
	}

	if (IsDown(VK_CONTROL)) {
		if (IsMeta(nApp, bM_)) {
			if (!m_nEnable[nApp][CONTROL_META_SHIFT][wParam]) {
				goto DO_NOTHING;
			}
		} else {
			if (bC_x) {
				if (!m_nEnable[nApp][CONTROLX][wParam] &&
					!m_nEnable[nApp][CONTROL][wParam] &&
					!m_nEnable[nApp][CONTROL_SHIFT][wParam]) {
					goto DO_NOTHING;
				} else if (!m_nEnable[nApp][CONTROLX][wParam]) {
					ModifyShell_NotifyIcon(CX_ICON, FALSE);
					bC_x = FALSE;
				}
			}

			if (!bC_x) {
				if (('A' <= wParam) && (wParam <= 'Z')) {
					if (!m_nEnable[nApp][CONTROL][wParam]) {
						goto DO_NOTHING;
					}
				} else if (IsDown(VK_SHIFT)) {
					if (!m_nEnable[nApp][CONTROL_SHIFT][wParam]) {
						goto DO_NOTHING;
					}
				} else {
					if (!m_nEnable[nApp][CONTROL][wParam]) {
						goto DO_NOTHING;
					}
				}
			}
		}
	} else if (IsMeta(nApp, bM_)) {
		if (('A' <= wParam) && (wParam <= 'Z')) {
			if (!m_nEnable[nApp][META][wParam]) {
				goto DO_NOTHING;
			}
		} else if (IsDown(VK_SHIFT)) {
			if (!m_nEnable[nApp][META_SHIFT][wParam]) {
				goto DO_NOTHING;
			}
		} else {
			if (!m_nEnable[nApp][META][wParam]) {
				goto DO_NOTHING;
			}
		}
	} else {
		if (bC_u) {
			// through all data
		} else if (!m_nEnable[nApp][NONE][wParam]) {
			if (!nRepeat) {
				goto DO_NOTHING;
			} else {
				ASSERT(0 <= wParam && wParam <= UCHAR_MAX);
				Kdu((BYTE)wParam, nRepeat);
				goto HOOK;
			}
		}
	}

	if (IsDown(VK_CONTROL)) {
		if (wParam == 'Q') {
			SetKeyboardHookFlag(!m_bHook);
			goto HOOK;
		}
	}
	if (!m_bHook) {
		goto DO_NOTHING;
	}

	m_bRightControl	= IsDown(VK_RCONTROL);
	m_bRightAlt		= IsDown(VK_RMENU);
	m_bRightShift	= IsDown(VK_RSHIFT);

	// C-?
	if (IsDown(VK_CONTROL)) {
		// C-M-?
		if (IsMeta(nApp, bM_)) {
			switch (wParam) {
			case '5':
				if (IsDown(VK_SHIFT)) {
					BOOL bIsAltDown = IsDown(VK_MENU);
					if (bIsAltDown) {
						ReleaseKey(VK_MENU);
					}

					if (!m_bSetMark) {
						ReleaseKey(VK_SHIFT);
					}
					bOriginalC_h = TRUE;
					Kdu('H');
					if (!m_bSetMark) {
						DepressKey(VK_SHIFT);
					}

					if (bIsAltDown) {
						DepressKey(VK_MENU);
					}

					goto HOOK;
				}
				goto DO_NOTHING;
			default:
				ASSERT(0);
				break;
			}
		}

		switch (wParam) {
		case 'A':
			// C-a: Home
			CuKduCd(VK_HOME);
			goto HOOK;

		case 'B':
			// C-b: Left
			CuKduCd(VK_LEFT, nRepeat);
			goto HOOK;

		case 'C':
			// C-x C-c: Alt-F4
			if (bC_x) {
				if (strnicmp(szApplicationName, "explorer.exe", sizeof(szApplicationName))) {
					CuAdKduKduAuCd(VK_SPACE, 'C');
				} else {
					CuAdKduAuCd(VK_F4);
				}
				goto HOOK;
			}
			break;

		case 'D':
			// C-d: Delete
			CuKduCd(VK_DELETE, nRepeat);
			goto HOOK;

		case 'E':
			// C-e: End
			CuKduCd(VK_END);
			goto HOOK;

		case 'F':
			if (bC_x) {
				// C-x C-f: Alt-F, Alt-O
				bOriginalM_f = TRUE;
				CuAdKduKduAuCd('F', 'O');
				goto HOOK;
			} else if (bOriginalC_f) {
				// Ctrl-F: Find...
				bOriginalC_f = FALSE;
				goto DO_NOTHING;
			} else {
				// C-f: Right		
				CuKduCd(VK_RIGHT, nRepeat);
				goto HOOK;
			}

		case 'G':
			// C-g: Keyboard quit
			{
				CString szDialogTitle;
				CUtils::GetFindDialogTitle(szApplicationName, sizeof(szApplicationName), &szDialogTitle);
				if (!szDialogTitle.IsEmpty()) {
					CuKduCd(VK_ESCAPE);
				}
				if (m_bSetMark) {
					ReleaseKey(VK_SHIFT);
					m_bSetMark = FALSE;
					ClickCaret(szApplicationName, sizeof(szApplicationName));
				}
				goto HOOK;
			}

		case 'H':
			if (bOriginalC_h) {
				// Ctrl-H: Replace...
				bOriginalC_h = FALSE;
				goto DO_NOTHING;
			} else {
				// C-h: Back space
				CuKduCd(VK_BACK, nRepeat);
				goto HOOK;
			}

		case 'I':
			// C-i: Tab
			CuKduCd(VK_TAB);
			goto HOOK;

		case 'J':
			// C-x C-j: Toggle IME
			if (bC_x) {
				ToggleIME();
				goto HOOK;
			}
			break;

		case 'K':
			// C-k: Shift-End, Shift-Delete, if the cursor is not at EOL (is End Of Line)
			//		Shift-Right, Cut, if the cursor is at EOL
			if (!strnicmp(szApplicationName, "123w.exe", sizeof(szApplicationName))) {
				// C-k: Shift-End, Control-x
//				CancelSelection(szApplicationName, sizeof(szApplicationName));
				CuSdKduSuCd(VK_END);
				Kdu('W');
				goto HOOK;
			}

			{
				static CString szOriginalClipboardText;
				// Do not try to do these command at once.
				// Clipboard has old data till you go out this function.
				static int nStep = 0;
				static CString szClipboardText;
				static BOOL bContinuous = FALSE;

				switch (nStep) {
				case 0:
//					CancelSelection(szApplicationName, sizeof(szApplicationName));
					{
//						CString sz;
//						sz.Format("wLastParam == %c (%d)", wLastParam, wLastParam);
//						AfxMessageBox(sz);
					}

					if (wLastParam == 'K') {
						bContinuous = TRUE;
					} else {
						bContinuous = FALSE;
//						CancelSelection(szApplicationName, sizeof(szApplicationName));
					}
					if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
						// wLastParam always 'K' on M$ Word.
						// I can NOT understand why does Xkeymacs behave like this.
						bContinuous = FALSE;
					}

					szOriginalClipboardText.Empty();
					if (!GetClipboardText(&szOriginalClipboardText)) {
						szOriginalClipboardText.Empty();
					}

					if (!CopyNextCharacter()) {
//						AfxMessageBox("Error: CopyNextCharacter");
						goto DO_NOTHING;
					}
					nStep = 1;
					goto RECURSIVE;
				case 1:
					nStep = 0;

					szClipboardText.Empty();
					GetClipboardText(&szClipboardText);

//					{
//						CString sz;
//						sz.Format("%x, %s", szClipboardText.GetAt(0), szClipboardText);
//						AfxMessageBox(sz);
//					}

					if (szClipboardText.IsEmpty()) {	// EOF
//						AfxMessageBox("EOF");
						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "frontpg.exe", sizeof(szApplicationName)) ||
							!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
							CuKduCd(VK_END);
							CuSdKduSuCd(VK_RIGHT);
							Kdu('W');
							nStep = 2;
							goto RECURSIVE;
						} else if (!strnicmp(szApplicationName, "nlnotes.exe", sizeof(szApplicationName))) {
							CuKduCd(VK_END);
							CuSdKduSuCd(VK_DOWN);
							CuSdKduSuCd(VK_HOME);
							Kdu('W');
							nStep = 2;
							goto RECURSIVE;
						} else {
							// default
							CuKduCd(VK_RIGHT);
							if (!SetClipboardText(&szOriginalClipboardText)) {
								//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
							}
							goto HOOK;
						}
					}

					if (szClipboardText.GetAt(0) != VK_RETURN) {
						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
							CuSdKduKduSuCd(VK_END, VK_LEFT);
							CuSdKduSuCd(VK_DELETE);
						} else {
							CuSdKduKduSuCd(VK_END, VK_DELETE);

//							if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
//								!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
							if (!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
								CuKduCd(VK_RETURN);
								CuKduCd(VK_LEFT);
							}
						}

//						CuSdKduSuCd(VK_END);
//						if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
//							!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
//							CuSdKduSuCd(VK_LEFT);
//						}
//						Kdu('W');
					} else {
						CuSdKduSuCd(VK_RIGHT);
						Kdu('W');
					}

					nStep = 2;
					goto RECURSIVE;
				case 2:
					{
						nStep = 0;
						szClipboardText.Empty();
						GetClipboardText(&szClipboardText);

//						CString sz;
//						sz.Format("%x, %x, %x, %x, %x, %x, %s", szClipboardText.GetAt(0), szClipboardText.GetAt(1), szClipboardText.GetAt(2), szClipboardText.GetAt(3), szClipboardText.GetAt(4), szClipboardText.GetAt(5), szClipboardText);
//						AfxMessageBox(sz);

						int nEnter = szClipboardText.Find(VK_RETURN, 1);
						if ( nEnter != -1 ) {
							CuKduCd(VK_RETURN);
							CuKduCd(VK_LEFT);
							szClipboardText = szClipboardText.Left(nEnter);
						}

						nStep = 3;
						goto RECURSIVE;
					}
				case 3:
					nStep = 0;
					if (!szClipboardText.IsEmpty()) {
						if (!SetClipboardText(&szClipboardText)) {
							//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
						}
					}

					// If you check wLastParam here, wLastParam is always 'K', cos ...
					// So I set bContinuous in Step 0.
					if (bContinuous) {
						CString szClipboardText1;
						GetClipboardText(&szClipboardText1);
						szOriginalClipboardText += szClipboardText1;
						SetClipboardText(&szOriginalClipboardText);
					}

					nStep = 4;
					goto RECURSIVE;
				case 4:
					nStep = 0;
					AddKillRing(nApp);
					goto HOOK;
					break;
				}
			}

		case 'L':
			// C-l: Recenter
			if (!strnicmp(szApplicationName, "b2.exe", sizeof(szApplicationName))) {
				static int nStep = 0;
				RECT ClientRect;
				GetClientRect(GetFocus(), &ClientRect);
				static int gap = INT_MAX;

				static POINT CaretPos;
				GetCaretPos(&CaretPos);

				switch (nStep) {
				case 0:
					nStep = 0;	// omaginai
					if (CaretPos.y < ClientRect.bottom / 2) {
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
					} else if (ClientRect.bottom / 2 < CaretPos.y) {
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEDOWN, NULL);
					} else {
						gap = INT_MAX;
						goto HOOK;
						break;
					}

					CuKduCd(VK_DOWN);
					nStep = 1;
					goto RECURSIVE;

				case 1:
					nStep = 0;
					// When a client screen can display 2n lines, the center line is (n + 1)th line.
					int newgap = CaretPos.y - ClientRect.bottom / 2;
					if (fabs(gap) <= fabs(newgap)) {
						if ((fabs(gap) == fabs(newgap)) && (gap != newgap) && newgap < 0) {
							SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
						}
						gap = INT_MAX;
						goto HOOK;
						break;
					}

					gap = newgap;
					goto RECURSIVE;
				}
			} else {
				RECT ClientRect;
				GetClientRect(GetFocus(), &ClientRect);
				int gap = INT_MAX;

				for (;;) {
					POINT CaretPos;
					GetCaretPos(&CaretPos);

					if (CaretPos.y < ClientRect.bottom / 2) {
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
					} else if (ClientRect.bottom / 2 < CaretPos.y) {
						SendMessage(GetFocus(), WM_VSCROLL, SB_LINEDOWN, NULL);
					} else {
						break;
					}

					// When a client screen can display 2n lines, the center line is (n + 1)th line.
					int newgap = CaretPos.y - ClientRect.bottom / 2;
					if (fabs(gap) <= fabs(newgap)) {
						if ((fabs(gap) == fabs(newgap)) && (gap != newgap) && newgap < 0) {
							SendMessage(GetFocus(), WM_VSCROLL, SB_LINEUP, NULL);
						}
						break;
					}
					gap = newgap;
				}
				goto HOOK;
			}

		case 'M':
			// C-m: Enter
			CuKduCd(VK_RETURN, nRepeat);
			goto HOOK;

		case 'N':
			// C-n: Down
			CuKduCd(VK_DOWN, nRepeat);
			goto HOOK;

		case 'O':
			if (bOriginalC_o) {
				// Ctrl-o: Open...
				bOriginalC_o = FALSE;
				goto DO_NOTHING;
			} else {
				if (m_nEnable[nApp][CONTROL][wParam] == 1) {	// C-o: open-line
					CuKduKduCd(VK_RETURN, VK_LEFT);
				} else {	// C-o: Toggle IME
					ToggleIME();
				}
				goto HOOK;
			}

		case 'P':
			// C-x C-p: Ctrl-End, Ctrl-Shift-Home
			if (bC_x) {
				Kdu(VK_END);
				DepressKey(VK_SHIFT);
				Kdu(VK_HOME);
				ReleaseKey(VK_SHIFT);
				goto HOOK;
			}

			// C-p: Up
			CuKduCd(VK_UP, nRepeat);
			goto HOOK;

		case 'R':
			Search(BACKWARD, szApplicationName, sizeof(szApplicationName), &bOriginalC_f, &bOriginalM_b, &bOriginalM_f);
			goto HOOK;

		case 'S':
			// C-x C-s: Alt-F, Alt-S
			if (bC_x) {
				if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
					// M$ Word
					ModifyShell_NotifyIcon(CX_ICON, FALSE);
					bC_x = FALSE;
					goto DO_NOTHING;
				} else {
					// default
					bOriginalM_f = TRUE;
					CuAdKduKduAuCd('F', 'S');
					goto HOOK;
				}
			}

			// C-s:
			Search(FORWARD, szApplicationName, sizeof(szApplicationName), &bOriginalC_f, &bOriginalM_b, &bOriginalM_f);
			goto HOOK;

		case 'T':
			// C-t: Shift-Left, Shift-Delete, Right Shift-Insert, if the cursor is not at EOL (is End Of Line)
			//		Left, Shift-Right, Shift-Delete, Left, Shift-Insert, Right, if the cursor is at EOL
			{
				static CString szOriginalClipboardText;
				// Do not try to do these command at once.
				// Clipboard has old data till you go out this function.
				static int nStep = 0;
				switch (nStep) {
				case 0:
					if (wLastParam != 'T') {
						CancelSelection(szApplicationName, sizeof(szApplicationName));
					}
					szOriginalClipboardText.Empty();
					if (!GetClipboardText(&szOriginalClipboardText)) {
						szOriginalClipboardText.Empty();
					}
//					AfxMessageBox(szOriginalClipboardText);

					// simple version
					if (!strnicmp(szApplicationName, "123w.exe", sizeof(szApplicationName))) {
						// C-t: Left, Shift-Right, Shift-Delete, Left, Shift-Insert, Right
						ReleaseKey(VK_CONTROL);
						Kdu(VK_LEFT);
						DepressKey(VK_SHIFT);
						Kdu(VK_RIGHT);
						Kdu(VK_DELETE);
						ReleaseKey(VK_SHIFT);
						Kdu(VK_LEFT);
						DepressKey(VK_SHIFT);
						Kdu(VK_INSERT);
						ReleaseKey(VK_SHIFT);
						Kdu(VK_RIGHT);
						DepressKey(VK_CONTROL);
						nStep = 3;
						goto RECURSIVE;
						break;	// needless
					}
				
					if (!CopyBackCharacter()) {
						goto DO_NOTHING;
					}

					nStep = 1;
					goto RECURSIVE;
					break;	// needless
				case 1:
					{
						nStep = 0;
						CString szClipboardText;
						GetClipboardText(&szClipboardText);

//						CString sz;
//						sz.Format("%x, %d, %s", szClipboardText.GetAt(0), szClipboardText.GetLength(), szClipboardText);
//						AfxMessageBox(sz);

						// Top Of File
						if (szClipboardText.IsEmpty() ||		// for normal application
							szClipboardText.GetLength() >= 3) {	// for VC++
							CuKduCd(VK_LEFT);
							nStep = 3;
							goto RECURSIVE;
						}

						if (!CopyNextCharacter()) {
							nStep = 3;
							goto RECURSIVE;
						}

						nStep = 2;
						goto RECURSIVE;
						break;	// needless
					}
				case 2:
					{
						nStep = 0;
						CString szClipboardText;
						GetClipboardText(&szClipboardText);

//						CString sz;
//						sz.Format("%x, %d, %s", szClipboardText.GetAt(0), szClipboardText.GetLength(), szClipboardText);
//						AfxMessageBox(sz);

						if (!szClipboardText.IsEmpty() &&
							szClipboardText.GetAt(0) != VK_RETURN) {
							ReleaseKey(VK_CONTROL);
							DepressKey(VK_SHIFT);
							Kdu(VK_LEFT);
							Kdu(VK_DELETE);
							ReleaseKey(VK_SHIFT);
							Kdu(VK_RIGHT);
							DepressKey(VK_SHIFT);
							Kdu(VK_INSERT);
							ReleaseKey(VK_SHIFT);
							DepressKey(VK_CONTROL);
						} else {
							if (szClipboardText.IsEmpty()) {	// EOF
								if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName)) ||
									!strnicmp(szApplicationName, "frontpg.exe", sizeof(szApplicationName)) ||
									!strnicmp(szApplicationName, "nlnotes.exe", sizeof(szApplicationName)) ||
									!strnicmp(szApplicationName, "wordpro.exe", sizeof(szApplicationName))    ) {
									// These applications say "EOL is EOF".
									CuKduCd(VK_END);
								} else {
									// default
									CuKduCd(VK_RIGHT);
								}
							}

							ReleaseKey(VK_CONTROL);
							Kdu(VK_LEFT);
							DepressKey(VK_SHIFT);
							Kdu(VK_RIGHT);
							Kdu(VK_DELETE);
							ReleaseKey(VK_SHIFT);
							Kdu(VK_LEFT);
							DepressKey(VK_SHIFT);
							Kdu(VK_INSERT);
							ReleaseKey(VK_SHIFT);
							Kdu(VK_RIGHT);
							DepressKey(VK_CONTROL);
						}

						nStep = 3;
						goto RECURSIVE;
						break;	// needless
					}
				case 3:
					nStep = 0;
					if (!SetClipboardText(&szOriginalClipboardText)) {
						//AfxMessageBox("Fait to save original clipboard data"); // aryaryann koryaryann
					}
					goto HOOK;
					break;	// needless
				}
			}

		case 'U':
			// C-u: only set flag
			if (wLastParam == 'U') {
				nRepeat *= 4;
			} else {
				nRepeat = 4;
			}
			bC_u = TRUE;
			goto HOOKX;

		case 'V':
			if (bOriginalC_v) {
				// Ctrl-V: Paste
				bOriginalC_v = FALSE;
				goto DO_NOTHING;
			} else {
				// C-v: Page Down
				if (!strnicmp(szApplicationName, "notepad.exe", sizeof(szApplicationName))) {
					// notepad
					switch (ScrollUpDown(TRUE, nRepeat)) {
					case GOTO_RECURSIVE:
						goto RECURSIVE;
					case GOTO_HOOK:
						goto HOOK;
					default:
						ASSERT(0);
						goto HOOK;
					}
				} else {
					// default
					CuKduCd(VK_NEXT, nRepeat);
					goto HOOK;
				}
			}

		case 'W':
			// C-x C-w: Alt-F, Alt-A
			if (bC_x) {
				bOriginalM_f = TRUE;
				CuAdKduKduAuCd('F', 'A');
				goto HOOK;
			}

			// C-w: Ctrl-X
			{
				static int nStep = 0;
				switch (nStep) {
				case 0:
					if (IsDown(VK_SHIFT)) {
						ReleaseKey(VK_SHIFT);
					}
					bOriginalC_x = TRUE;
					Kdu('X');
					nStep = 1;
					goto RECURSIVE;
				case 1:
					nStep = 0;
					AddKillRing(nApp);
					goto HOOK;
				}
			}

		case 'X':
			if (bOriginalC_x) {
				// Ctrl-X: Cut
				bOriginalC_x = FALSE;
				goto DO_NOTHING;
			} else {
				// C-x: only set flag
				ModifyShell_NotifyIcon(CX_ICON, TRUE);
				bC_x = TRUE;
				goto HOOKX;
			}

		case 'Y':
			// C-y: Ctrl-V
			if (nRepeat == 0) {
				nRepeat = 1;
			}
			m_nKillRing += (nRepeat -1);
			GetKillRing(nApp);
			if (IsDown(VK_SHIFT)) {
				ReleaseKey(VK_SHIFT);
			}
			bOriginalC_v = TRUE;
			Kdu('V');
			goto HOOK;

		case 'Z':
			if (bOriginalC_z) {
				// Ctrl-Z: Undo
				bOriginalC_z = FALSE;
				goto DO_NOTHING;
			} else {
				// C-z: Alt-Space, Alt-N
				CuAdKduKduAuCd(VK_SPACE, 'N');
				goto HOOK;
			}

		case VK_RETURN:
			if (!strnicmp(szApplicationName, "nlnotes.exe", sizeof(szApplicationName)) ||
				!strnicmp(szApplicationName, "msimn.exe", sizeof(szApplicationName)) ||
				!strnicmp(szApplicationName, "outlook.exe", sizeof(szApplicationName))) {
				goto HOOK;
			}
			goto DO_NOTHING;

		case VK_SPACE:
			// C-space: Shift
			if (IsDown(VK_SHIFT)) {
				ReleaseKey(VK_SHIFT);
				ClickCaret(szApplicationName, sizeof(szApplicationName));
			}
			DepressKey(VK_SHIFT);
			m_bSetMark = TRUE;
			goto HOOK;

		case 0xBD:	// VK_OEM_MINUS Windows 2000/XP: For any country/region, the '-' key
					// Shift + '-' = '_' on 101 keyboard
			// C-_: Ctrl-Z (on 101 keyboard)
		case 0xBF:	// VK_OEM_2	Used for miscellaneous characters; it can vary by keyboard. 
					//			Windows 2000/XP: For the US standard keyboard, the '/?' key
			// C-/: Ctrl-Z
			if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
				PostMessage(GetFocus(), WM_KEYDOWN, 'Z', 0);
				goto HOOK;
			}
			bOriginalC_z = TRUE;
			Kdu('Z');
			goto HOOK;

		case 0xDB:	// VK_OEM_4	Used for miscellaneous characters; it can vary by keyboard. 
					//			Windows 2000/XP: For the US standard keyboard, the '[{' key
			bM_ = TRUE;
			goto HOOKX;

		case 0xE2:	// C-BACKSLASH of 106/109 keyboard: Toggle IME
					// C-_: Ctrl-Z (on 106 keyboard)
			if (IsDown(VK_SHIFT)) {
				if (!strnicmp(szApplicationName, "winword.exe", sizeof(szApplicationName))) {
					PostMessage(GetFocus(), WM_KEYDOWN, 'Z', 0);
					goto HOOK;
				}
				bOriginalC_z = TRUE;
				Kdu('Z');
				goto HOOK;
			} else {
				// C-BACKSLASH: Toggle IME
				// goto case 0xDC:
			}
		case 0xDC:	// C-\: Toggle IME
			ToggleIME();
			goto HOOK;

		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			// C-0...9
			nRepeat = nRepeat * 10 + (wParam - '0');
			goto HOOK0_9;

		default:
			ASSERT(0);
			break;
		}	// switch (wParam)
	}	// if (IsDown(VK_CONTROL))

	// M-?
	if (IsMeta(nApp, bM_)) {
		switch (M_Foo(wParam, wLastParam, nApp, nRepeat, szApplicationName, sizeof(szApplicationName),
			          &bOriginalC_h, &bOriginalC_v, &bOriginalC_z, &bOriginalM_b, &bOriginalM_f)) {
		case GOTO_HOOK:
			goto HOOK;
		case GOTO_RECURSIVE:
			goto RECURSIVE;
		case GOTO_DO_NOTHING:
			goto DO_NOTHING;
		default:
			ASSERT(0);
			goto DO_NOTHING;
		}
	}

	if (bC_u) {
		switch (wParam) {
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			// C-u 0...9
			if (wLastParam == 'U') {
				nRepeat = wParam - '0';
				wLastParam = 0;
			} else {
				nRepeat = nRepeat * 10 + (wParam - '0');
			}
			goto HOOK0_9;

		default:
			if (nRepeat) {
				Kdu((BYTE)wParam, nRepeat);
				goto HOOK;
			}
			goto HOOK0_9;
		}
	}

	switch (wParam) {
		case 'U':
			// C-x u: Ctrl-Z
			if (bC_x) {
				DepressKey(VK_CONTROL);
				PostMessage(GetFocus(), WM_KEYDOWN, 'Z', 0);
				ReleaseKey(VK_CONTROL);
				goto HOOK;
			}
			goto DO_NOTHING;

		case VK_ESCAPE:
			bM_ = TRUE;
			goto DO_NOTHING;

		case VK_LMENU:
		case VK_RMENU:
		case VK_MENU:
			goto DO_NOTHING;

		default:
			ASSERT(0);
			break;
	}

DO_NOTHING:
	ModifyShell_NotifyIcon(SHIFT_ICON, IsDown(VK_SHIFT));
	ModifyShell_NotifyIcon(CTRL_ICON, IsDown(VK_CONTROL));
	ModifyShell_NotifyIcon(ALT_ICON, IsDown(VK_MENU));
	if ((wParam != VK_SHIFT) &&
		(wParam != VK_CONTROL) &&
		(wParam != VK_MENU)) {
		wLastParam = wParam;
	}
	return ::CallNextHookEx(m_hHookKeyboard, nCode, wParam, lParam);

RECURSIVE:
//	LRESULT result;
//	result = ::CallNextHookEx(m_hHookKeyboard, nCode, wParam, lParam);
	ASSERT(0 <= wParam && wParam <= UCHAR_MAX);
	Kdu((BYTE)wParam);
//	return result;
	ModifyShell_NotifyIcon(SHIFT_ICON, IsDown(VK_SHIFT));
	ModifyShell_NotifyIcon(CTRL_ICON, IsDown(VK_CONTROL));
	ModifyShell_NotifyIcon(ALT_ICON, IsDown(VK_MENU));
	return TRUE;

HOOK:
	nRepeat	= 0;
	wLastParam = wParam;
	bC_u	= FALSE;
HOOK0_9:
	ModifyShell_NotifyIcon(CX_ICON, FALSE);
	bC_x	= FALSE;
	bM_		= FALSE;
HOOKX:
	ModifyShell_NotifyIcon(SHIFT_ICON, IsDown(VK_SHIFT));
	ModifyShell_NotifyIcon(CTRL_ICON, IsDown(VK_CONTROL));
	ModifyShell_NotifyIcon(ALT_ICON, IsDown(VK_MENU));
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// CXkeymacsData Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXkeymacsData::CXkeymacsData()
{
	ClearAll();
}

CXkeymacsData::~CXkeymacsData()
{

}

// set application name
void CXkeymacsData::SetApplicationName(LPCTSTR lpszApplicationName)
{
	m_strApplicationName.Format(lpszApplicationName);
}

// return application name
CString CXkeymacsData::GetApplicationName()
{
	return m_strApplicationName;
}

// set hook or not
void CXkeymacsData::SetEnable(int nCommandType, int nKey, int nEnable)
{
	ASSERT(0 <= nCommandType	|| nCommandType	< MAX_COMMAND_TYPE);
	ASSERT(0 <= nKey			|| nKey			< MAX_KEY);

	m_nEnable[nCommandType][nKey] = nEnable;
}

// return hook or not
int CXkeymacsData::GetEnable(int nCommandType, int nKey)
{
	ASSERT(0 <= nCommandType	|| nCommandType	< MAX_COMMAND_TYPE);
	ASSERT(0 <= nKey			|| nKey			< MAX_KEY);

	return m_nEnable[nCommandType][nKey];
}

// clear all data
void CXkeymacsData::ClearAll()
{
	ZeroMemory(m_nEnable, sizeof(m_nEnable));
	m_strApplicationName.Empty();
}

// set application name
void CXkeymacsDll::SetApplicationName(int nApp, CString szApplicationName)
{
	ZeroMemory(m_szSpecialApp[nApp], sizeof(m_szSpecialApp[nApp]));
	strncpy(m_szSpecialApp[nApp], szApplicationName, sizeof(m_szSpecialApp[nApp]));
}

// return root window of focused window
HWND CXkeymacsDll::GetFocusRoot()
{
	HWND hWnd, hRootWnd;
	for (hRootWnd = hWnd = GetFocus(); hWnd; hWnd = GetParent(hWnd)) {
		hRootWnd = hWnd;
	}
	return hRootWnd;
}

// set m_nEnable[nApp][nCommandType][nKey] nEnable
void CXkeymacsDll::SetEnable(int nApp, int nCommandType, int nKey, int nEnable)
{
	m_nEnable[nApp][nCommandType][nKey] = nEnable;
}

void CXkeymacsDll::SetKillRingMax(int nApp, int nKillRingMax)
{
	m_nKillRingMax[nApp] = nKillRingMax;
}

// Clear data of nApp
void CXkeymacsDll::Clear(int nApp)
{
	if (0 <= nApp && nApp < MAX_APP) {
		ZeroMemory(m_szSpecialApp[nApp], sizeof(m_szSpecialApp[nApp]));
		ZeroMemory(m_nEnable[nApp], sizeof(m_nEnable[nApp]));
		m_nKillRingMax[nApp] = 0;
	} else {
		ASSERT(0);
	}
}

// Set m_hPrevWnd 0 for that KeyboardProc() updates data 
void CXkeymacsDll::UpdateData()
{
	m_hPrevWnd = 0;
}

void CXkeymacsData::SetApplicationTitle(LPCTSTR lpszApplicationTitle)
{
	m_strApplicationTitle.Format(lpszApplicationTitle);
}

CString CXkeymacsData::GetApplicationTitle()
{
	return m_strApplicationTitle;
}

void CXkeymacsData::SetKillRingMax(int nKillRingMax)
{
	m_nKillRingMax = nKillRingMax;
}

int CXkeymacsData::GetKillRingMax()
{
	return m_nKillRingMax;
}

BOOL CXkeymacsDll::GetClipboardText(CString *szClipboardText)
{
	if (!OpenClipboard(NULL)) {
//		AfxMessageBox("Cannot open the Clipboard");
		return FALSE;
	}

	HANDLE hClipboardText;
//	if ((hClipboardText = ::GetClipboardData(CF_TEXT)) == NULL) {
	if ((hClipboardText = ::GetClipboardData(CF_OEMTEXT)) == NULL) {
		DWORD dw = GetLastError();
		CString szMessage;
		szMessage.Format("Unable to get Clipboard data: %d", dw);
//		AfxMessageBox(szMessage);
		CloseClipboard();
		return FALSE;
	}

	szClipboardText->Format("%s", hClipboardText);
	EmptyClipboard();
	CloseClipboard();
	return TRUE;
}

BOOL CXkeymacsDll::SetClipboardText(CString *szClipboardText)
{
	if (!OpenClipboard(NULL)) {
//		AfxMessageBox("Cannot open the Clipboard in SetClipboardText");
		return FALSE;
	}

	int nLength = szClipboardText->GetLength() + 1;
	HGLOBAL hClipboardText = GlobalAlloc(GHND, nLength);
	if (hClipboardText == NULL) {
//		AfxMessageBox("Failed: GlobalAlloc in SetClipboardText");
		return FALSE;
	}

	LPSTR lpStr = (LPSTR)GlobalLock(hClipboardText);
	lstrcpyn(lpStr, *szClipboardText, nLength);
	GlobalUnlock(hClipboardText);
	EmptyClipboard();

	if ((hClipboardText = ::SetClipboardData(CF_OEMTEXT, hClipboardText)) == NULL) {
//		DWORD dw = GetLastError();
//		CString szMessage;
//		szMessage.Format("Unable to set Clipboard data: %d", dw);
//		AfxMessageBox(szMessage);
		CloseClipboard();
		return FALSE;
	}

	CloseClipboard();
	return TRUE;

}

int CXkeymacsDll::M_Foo(WPARAM wParam, WPARAM wLastParam, int nApp, int nRepeat,
						char* szApplicationName, int nApplicationNameLength,
						BOOL *bOriginalC_h, BOOL *bOriginalC_v, BOOL *bOriginalC_z,
						BOOL *bOriginalM_b, BOOL *bOriginalM_f)
{
	BOOL bIsAltDown = IsDown(VK_MENU);

	switch (wParam) {
	case 'B':
		if (bIsAltDown) {
			if (*bOriginalM_b) {
				*bOriginalM_b = FALSE;
				return GOTO_DO_NOTHING;
			}
		}

		// M-b: backward-word
		if (bIsAltDown) {
			ReleaseKey(VK_MENU);
		}

		CdKduCu(VK_LEFT, nRepeat);

		if (bIsAltDown) {
			DepressKey(VK_MENU);
		}

		return GOTO_HOOK;

	case 'F':
		if (bIsAltDown) {
			if (*bOriginalM_f) {
				*bOriginalM_f = FALSE;
				return GOTO_DO_NOTHING;
			}
		}

		// M-f: forward-word
		if (bIsAltDown) {
			ReleaseKey(VK_MENU);
		}

		CdKduCu(VK_RIGHT, nRepeat);

		if (bIsAltDown) {
			DepressKey(VK_MENU);
		}

		return GOTO_HOOK;

	case 'I':
		AuKduAd(VK_TAB);
		return GOTO_HOOK;

	case 'V':
		{
			// M-v: Page Up
			if (bIsAltDown) {
				ReleaseKey(VK_MENU);
			}

			int rc = GOTO_HOOK;
			if (!strnicmp(szApplicationName, "notepad.exe", nApplicationNameLength)) {
				// notepad
				rc = ScrollUpDown(FALSE, nRepeat);
			} else {
				Kdu(VK_PRIOR, nRepeat);
			}

			if (bIsAltDown) {
				DepressKey(VK_MENU);
			}

			return rc;
		}

	case 'W':
		// M-w: Ctrl-C
		{
			static int nStep = 0;
			switch (nStep) {
			case 0:
				if (bIsAltDown) {
					ReleaseKey(VK_MENU);
				}

				if (IsDown(VK_SHIFT)) {
					ReleaseKey(VK_SHIFT);
				}

				CdKduCu('C');

				if (bIsAltDown) {
					DepressKey(VK_MENU);
				}

				nStep = 1;
				return GOTO_RECURSIVE;
			case 1:
				nStep = 0;
				AddKillRing(nApp);

				return GOTO_HOOK;
			}
		}

	case 'Y':
		// M-y: yank-pop
		if (wLastParam == 'Y') {
			m_nKillRing++;
			GetKillRing(nApp);

			if (bIsAltDown) {
				ReleaseKey(VK_MENU);
			}

			if (IsDown(VK_SHIFT)) {
				ReleaseKey(VK_SHIFT);
			}

			*bOriginalC_z = TRUE;
			*bOriginalC_v = TRUE;
			CdKduKduCu('Z', 'V');

			if (bIsAltDown) {
				DepressKey(VK_MENU);
			}
		}

		return GOTO_HOOK;

	case 0xBC:	// VK_OEM_COMMA Windows 2000/XP: For any country/region, the ',' key
		// M-<:
		if (IsDown(VK_SHIFT)) {

			if (bIsAltDown) {
				ReleaseKey(VK_MENU);
			}

			if (!m_bSetMark) {
				ReleaseKey(VK_SHIFT);
			}
			CdKduCu(VK_HOME);
			if (!m_bSetMark) {
				DepressKey(VK_SHIFT);
			}

			if (bIsAltDown) {
				DepressKey(VK_MENU);
			}

			return GOTO_HOOK;
		}
		break;

	case 0xBE:	// VK_OEM_PERIOD Windows 2000/XP: For any country/region, the '.' key
		// M->:
		if (IsDown(VK_SHIFT)) {

			if (bIsAltDown) {
				ReleaseKey(VK_MENU);
			}

			if (!m_bSetMark) {
				ReleaseKey(VK_SHIFT);
			}
			CdKduCu(VK_END);
			if (!m_bSetMark) {
				DepressKey(VK_SHIFT);
			}

			if (bIsAltDown) {
				DepressKey(VK_MENU);
			}

			return GOTO_HOOK;
		}
		break;

	case '1':
		// M-!: cmd.exe/command.com
		if (IsDown(VK_SHIFT)) {
			STARTUPINFO si;
			memset(&si, 0, sizeof(STARTUPINFO));
			PROCESS_INFORMATION pi;
			memset(&pi, 0, sizeof(PROCESS_INFORMATION));

			char *terminal = getenv("COMSPEC");
			if (terminal) {
				CreateProcess(NULL, terminal, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
			}
			return GOTO_HOOK;
		}
		break;

	case '5':
		if (IsDown(VK_SHIFT)) {

			if (bIsAltDown) {
				ReleaseKey(VK_MENU);
			}

			if (!m_bSetMark) {
				ReleaseKey(VK_SHIFT);
			}
			*bOriginalC_h = TRUE;
			CdKduCu('H');
			if (!m_bSetMark) {
				DepressKey(VK_SHIFT);
			}

			if (bIsAltDown) {
				DepressKey(VK_MENU);
			}

			return GOTO_HOOK;
		}
		break;

	default:
		if (bIsAltDown) {
			ASSERT(0);
		}
		break;
	}
	return GOTO_DO_NOTHING;
}

BOOL CXkeymacsDll::IsMeta(int nApp, BOOL bM_)
{
	switch (m_OsVersionInfo.dwPlatformId) {
	case VER_PLATFORM_WIN32_NT:
		return (IsDown(VK_RMENU) && m_nEnable[nApp][NONE][VK_RMENU]) ||
			   (IsDown(VK_LMENU) && m_nEnable[nApp][NONE][VK_LMENU]) ||
			   bM_;
		break;
	case VER_PLATFORM_WIN32_WINDOWS:
		return (IsDown(VK_MENU) && m_nEnable[nApp][NONE][VK_MENU]) ||
			   bM_;
		break;
	default:
		return FALSE;
		break;
	}
}

int CXkeymacsDll::GetMickey(int nDifferential, int nThreshold1, int nThreshold2, int nAcceleration, int nSpeed)
{
	nDifferential = nDifferential * 10 / nSpeed;

	switch (nAcceleration) {
	case 2:
		if (nThreshold2 < fabs(nDifferential / 4)) {
			nDifferential /= 4;
			break;
		}
		// Do NOT write break; here.
	case 1:
		if (nThreshold1 < fabs(nDifferential / 2)) {
			nDifferential /= 2;
		}
		break;
	case 0:
		break;
	default:
		ASSERT(0);
		break;
	}

	return nDifferential;
}

int CXkeymacsDll::ScrollUpDown(BOOL bUp, int nRepeat)
{
	static int nStep = 0;
	static HWND hWnd = NULL;
	static int nNewPos = 0;

	switch (nStep) {
	case 0:
		{
			hWnd = GetFocus();
			SCROLLINFO scrollinfo = {'\0'};
			scrollinfo.cbSize = sizeof(SCROLLINFO);
			scrollinfo.fMask = SIF_ALL;
			if (!GetScrollInfo(hWnd, SB_VERT, &scrollinfo)) {
//				CString sz;
//				sz.Format("GetScrollInfo: max = %d, page = %d, pos = %d, error = %d",
//						  scrollinfo.nMax, scrollinfo.nPage, scrollinfo.nPos, GetLastError());
//				AfxMessageBox(sz);
				goto DEFAULT;
			}

			int nScrollLines = scrollinfo.nPage - 2;	// number of lines to scroll per a M-v
			if (nScrollLines < 1) {
				nScrollLines = 1;
			}

			int nAllScrollLines;	// number of lines to scroll
			if (nRepeat) {
				nAllScrollLines = nScrollLines * nRepeat;
			} else {
				nAllScrollLines = nScrollLines;
			}
			int nOldPos = scrollinfo.nPos;
			if (bUp) {
				nNewPos = scrollinfo.nPos + nAllScrollLines;
				if ((int)(scrollinfo.nMax - scrollinfo.nPage + 1) < nNewPos) {
					nNewPos = scrollinfo.nMax - scrollinfo.nPage + 1;
				}
			} else {
				nNewPos = scrollinfo.nPos - nAllScrollLines;
				if (nNewPos < scrollinfo.nMin) {
					nNewPos = scrollinfo.nMin;
				}
			}
			nAllScrollLines = (int)fabs(nNewPos - nOldPos);

			RECT ClientRect;
			if (!GetClientRect(hWnd, &ClientRect)) {
//				AfxMessageBox("GetClientRect");
				goto DEFAULT;
			}

			POINT CaretPos = {'\0'};
			if (!GetCaretPos(&CaretPos)) {
//				AfxMessageBox("GetCaretPos");
				goto DEFAULT;
			}

			int nLineHight = ClientRect.bottom / (scrollinfo.nPage + 1);
			int nCaretLine = CaretPos.y / nLineHight;	// nCaretLine start from 0
			int nSpace = 0;	// space to scroll w/o hiding caret
			if (bUp) {
				nSpace = nCaretLine;
			} else {
				nSpace = scrollinfo.nPage - nCaretLine - 1;
			}
			if (scrollinfo.nPage == 1) {
				if (bUp) {
					CuKduCd(VK_DOWN, nRepeat);
					CuKduCd(VK_HOME);
				} else {
					Kdu(VK_UP, nRepeat);
					Kdu(VK_HOME);
				}
			} else {
				if (nSpace < nAllScrollLines) {	// move the caret
					if (bUp) {
						CuKduCd(VK_DOWN, nAllScrollLines - nSpace);
						CuKduCd(VK_HOME);
						if (nRepeat) {	// I do NOT understand why is this needed.
							CuKduCd(VK_DOWN);
						}
					} else {
//						CString sz;
//						sz.Format("all = %d, space = %d", nAllScrollLines, nSpace);
//						AfxMessageBox(sz);
						Kdu(VK_UP, nAllScrollLines - nSpace);
						Kdu(VK_HOME);
						if (nRepeat) {	// I do NOT understand why is this needed.
							Kdu(VK_UP);
						}
					}
				}
			}
		}
		nStep = 1;
		return GOTO_RECURSIVE;
		break;
	case 1:
		nStep = 0;
		SendMessage(hWnd, WM_VSCROLL, SB_THUMBPOSITION | (nNewPos * 0x10000), NULL);
		break;
	}
	return GOTO_HOOK;

DEFAULT:
	if (bUp) {
		CuKduCd(VK_NEXT, nRepeat);
	} else {
		Kdu(VK_PRIOR, nRepeat);
	}
	return GOTO_HOOK;
}

DWORD CXkeymacsDll::ClickCaret(char* szApplicationName, int nApplicationNameLength)
{
	if (!strnicmp(szApplicationName, "winword.exe", nApplicationNameLength)) {
		// GetCaretPos always returen (x,y) = (0,0) on M$ Word, so ...
		CuKduCd(VK_RIGHT);
		return ERROR_SUCCESS;	// i.e. return 0;
	}

	HWND hWnd = GetFocus();

	POINT CursorPos = {'\0'};
	if (!GetCursorPos(&CursorPos)) {
		return GetLastError();
	}

	POINT CaretPos = {'\0'};
	if (!GetCaretPos(&CaretPos)) {
		return GetLastError();
	}
	{
//		CString sz;
//		sz.Format("x = %d, y = %d", CaretPos.x, CaretPos.y);
//		AfxMessageBox(sz);
	}
	if (!ClientToScreen(hWnd, &CaretPos)) {
		return GetLastError();
	}
	{
//		CString sz;
//		sz.Format("x = %d, y = %d", CaretPos.x, CaretPos.y);
//		AfxMessageBox(sz);
	}

	if (!SetCursorPos(CaretPos.x, CaretPos.y + 1)) {
		return GetLastError();
	}
	mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, GetMessageExtraInfo());
	mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, GetMessageExtraInfo());
	if (!SetCursorPos(CursorPos.x, CursorPos.y)) {
		return GetLastError();
	}
	return ERROR_SUCCESS;	// i.e. return 0;
}

DWORD CXkeymacsDll::CancelSelection(char* szApplicationName, int nApplicationNameLength)
{
	if (m_bSetMark) {
		ReleaseKey(VK_SHIFT);
		m_bSetMark = FALSE;
	}
	return ClickCaret(szApplicationName, nApplicationNameLength);
}

void CXkeymacsDll::AddKillRing(int nApp)
{
	if (*m_pnKillRingMax == 0) {
		return;
	}

	if (m_pKillRing[nApp] == NULL) {
		m_pKillRing[nApp] = new CStringList();
	}

	CString szClipboardText;
	GetClipboardText(&szClipboardText);
	m_pKillRing[nApp]->AddHead(szClipboardText);
	SetClipboardText(&szClipboardText);

	m_nKillRing = 0;

	if (*m_pnKillRingMax < m_pKillRing[nApp]->GetCount()) {
		m_pKillRing[nApp]->RemoveTail();
	}
}

void CXkeymacsDll::GetKillRing(int nApp)
{
	if (*m_pnKillRingMax == 0) {
		return;
	}

	if ((m_pKillRing[nApp] == NULL) || (m_pKillRing[nApp]->IsEmpty())) {
		return;
	}

	m_nKillRing %= m_pKillRing[nApp]->GetCount();
	CString sz = m_pKillRing[nApp]->GetAt(m_pKillRing[nApp]->FindIndex(m_nKillRing));
	SetClipboardText(&sz);
}
