// xkeymacs.h: interface for the CXkeymacsDll class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XKEYMACS_H__88552DEC_1233_4A0A_BE62_9EF7BC618EC6__INCLUDED_)
#define AFX_XKEYMACS_H__88552DEC_1233_4A0A_BE62_9EF7BC618EC6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

HINSTANCE GetThisHInst();

enum { MAX_APP = 64 };
enum { NONE, CONTROL, CONTROL_SHIFT, CONTROLX, CONTROL_META_SHIFT, META, META_SHIFT, MAX_COMMAND_TYPE };
enum { MAX_KEY = 256 };

enum { WINDOW_NAME_LENGTH	= 128 };
enum { CLASS_NAME_LENGTH	= 128 };
enum { SUB_KEY_NAME_LENGTH	= 128 };

enum SEARCH_DIRECTION { NA, FORWARD, BACKWARD };
enum icons { MAIN_ICON, CX_ICON, SHIFT_ICON, CTRL_ICON, ALT_ICON, MAX_ICON };

enum { GOTO_DO_NOTHING, GOTO_HOOK, GOTO_RECURSIVE };

class CSearchKey {
public:
	CSearchKey();
	CSearchKey(char* szApplicationName, int nApplicationNameLength, CString *szDialogTitle);
	BYTE m_bFindWhat;
	BYTE m_bDirectionForward;
	BYTE m_bDirectionBackward;
	BYTE m_bSearchOption;
};

class CSearch {
public:
	CSearch(char* szApplicationName, int nApplicationNameLength);
	CString m_szDialogTitle;
	CSearchKey* m_pKey;
};

class AFX_EXT_CLASS CXkeymacsDll  
{
public:
	void SetKillRingMax(int nApp, int nKillRingMax);
	void CXkeymacsDll::EnableShell_NotifyIcon(icons icon, BOOL bEnable);
	int AddShell_NotifyIcon(icons icon);
	int DeleteShell_NotifyIcon(icons icon);
	void SetNotifyIconData(icons icon, NOTIFYICONDATA stNtfyIcon, HICON hIconEnable, HICON hIconDisable, BOOL bEnable);
	void UpdateData();
	void Clear(int nApp);
	BOOL IsKeyboardHook();
	void SetEnable(int nApp, int nCommandType, int nKey, int nEnable);
	void SetApplicationName(int nApp, CString szApplicationName);
	BOOL ReleaseKeyboardHook();
	BOOL SetKeyboardHook();
	static void SetKeyboardHookFlag(BOOL bFlag);
	CXkeymacsDll();
	virtual ~CXkeymacsDll();

private:
	static BOOL IsMeta(int nApp, BOOL bM_);
	static BOOL IsDown(BYTE bVk);
	static int M_Foo(WPARAM wParam, WPARAM wLastParam, int nApp, int nRepeat,
					 char *szApplicationName, int nApplicationNameLength,
					 BOOL *bOriginalC_h, BOOL *bOriginalC_v, BOOL *bOriginalC_z, 
					 BOOL *bOriginalM_b, BOOL *bOriginalM_f);
	static BOOL SetClipboardText(CString *szClipboardText);
	static BOOL CopyBackCharacter();
	static BOOL CopyNextCharacter();
	static BOOL GetClipboardText(CString *szClipboardText);
	static void ToggleIME();
	static void DoKeybd_event(BYTE bVk, DWORD dwFlags);
	static void DepressKey(BYTE bVk);
	static void ReleaseKey(BYTE bVk);
	static void Kdu(BYTE bVk, int n);
	static void CuKduCd(BYTE bVk, int n);
	static void CuKduKduCd(BYTE bVk1, BYTE bVk2);
	static void CuAdKduAuCd(BYTE bVk);
	static void CuAdKduKduAuCd(BYTE bVk1, BYTE bVk2);
	static void CuAdKduKduKduAuCd(BYTE bVk1, BYTE bVk2, BYTE bVk3);
	static void CuSdKduSuCd(BYTE bVk, int n);
	static void CuSdKduKduSuCd(BYTE bVk1, BYTE bVk2);
	static void AuKduAd(BYTE bVk);
	static void CdKduKduCu(BYTE bVk1, BYTE bVk2);
	static void CdKduCu(BYTE bVk, int n);
	static LRESULT CALLBACK KeyboardProc(int nCode, WPARAM wParam, LPARAM lParam);
	static LRESULT CALLBACK CallWndProc(int nCode, WPARAM wParam, LPARAM lParam);
	static LRESULT CALLBACK GetMessageProc(int nCode, WPARAM wParam, LPARAM lParam);
	static HHOOK m_hHookKeyboard;
	static HHOOK m_hHookCallWnd;
	static HHOOK m_hHookGetMessage;
	static BOOL m_bImeComposition;
protected:
	static void GetKillRing(int nApp);
	static int m_nKillRing;
	static CStringList *m_pKillRing[MAX_APP];
	static int *m_pnKillRingMax;
	static int m_nKillRingMax[MAX_APP];
	static void AddKillRing(int nApp);
	static DWORD CancelSelection(char *szApplicationName, int nApplicationNameLength);
	static DWORD ClickCaret(char *szApplicationName, int nApplicationNameLength);
	static int ScrollUpDown(BOOL bUp, int nRepeat);
	static int GetMickey(int nDifferential, int nThreshold1, int nThreshold2, int nAcceleration, int nSpeed);
	static BOOL m_bSetMark;
	static char m_szIMEName[MAX_PATH];
	static int ModifyShell_NotifyIcon(icons icon, BOOL bNewStatus);
	static BOOL DoShell_NotifyIcon(icons icon, DWORD dwMessage);
	static BOOL m_bIcon[MAX_ICON];
	static HICON m_hDisable[MAX_ICON];
	static HICON m_hEnable[MAX_ICON];
	static NOTIFYICONDATA m_stNtfyIcon[MAX_ICON];
	static BOOL m_bHook;
	static BOOL m_bRightShift;
	static BOOL m_bRightAlt;
	static BOOL m_bRightControl;
	static SEARCH_DIRECTION m_CurrentDirection;
	static void SearchSetDirection(SEARCH_DIRECTION direction, char *szApplicationName, int nApplicationNameLength,
								   BOOL *bOriginalM_b, BOOL *bOriginalM_f, CSearch* pSearch);
	static void Search(SEARCH_DIRECTION direction, char *szApplicationName, int nApplicationNameLength, BOOL *bOriginalC_f, BOOL *bOriginalM_b, BOOL *bOriginalM_f);
	static OSVERSIONINFO m_OsVersionInfo;
	static HWND m_hPrevWnd;
	static char m_szSpecialApp[MAX_APP][CLASS_NAME_LENGTH];
	static int m_nEnable[MAX_APP][MAX_COMMAND_TYPE][MAX_KEY];
	static HWND GetFocusRoot();
};


class AFX_EXT_CLASS CXkeymacsData  
{
public:
	void SetKillRingMax(int nKillRingMax);
	int GetKillRingMax();
	CString GetApplicationTitle();
	void SetApplicationTitle(LPCTSTR lpszApplicationTitle);
	void ClearAll();
	int GetEnable(int nCommandType, int nKey);
	void SetEnable(int nCommandType, int nKey, int nEnable);
	CString GetApplicationName();
	void SetApplicationName(LPCTSTR lpszApplicationName);
	CXkeymacsData();
	virtual ~CXkeymacsData();

protected:
	int m_nKillRingMax;
	CString m_strApplicationTitle;
	CString m_strApplicationName;
	int m_nEnable[MAX_COMMAND_TYPE][MAX_KEY];
};

#endif // !defined(AFX_XKEYMACS_H__88552DEC_1233_4A0A_BE62_9EF7BC618EC6__INCLUDED_)
